Index: sheepdog/lib/work.c
===================================================================
--- sheepdog.orig/lib/work.c
+++ sheepdog/lib/work.c
@@ -76,6 +76,10 @@ static void *worker_routine(void *arg);
 
 #define TID_MAX_DEFAULT 0x8000 /* default maximum tid for most systems */
 
+#ifndef EFD_SEMAPHORE
+#define EFD_SEMAPHORE 00000001
+#endif
+
 static size_t tid_max;
 static unsigned long *tid_map;
 static struct sd_mutex tid_map_lock = SD_MUTEX_INITIALIZER;
Index: sheepdog/sheep/group.c
===================================================================
--- sheepdog.orig/sheep/group.c
+++ sheepdog/sheep/group.c
@@ -360,7 +360,7 @@ int epoch_log_read_remote(uint32_t epoch
 		nodes_len = rsp->data_length - sizeof(*timestamp);
 		memcpy((void *)nodes, buf, nodes_len);
 		if (timestamp)
-			memcpy(timestamp, buf + nodes_len, sizeof(*timestamp));
+			memcpy(timestamp, buf + nodes_len, sizeof(time_t));
 
 		return nodes_len / sizeof(struct sd_node);
 	}
